package xena;

import xena.XenaAPI.streamRateTypes;
import xena.XenaAPI.streamStates;
import xena.XenaPacket.packetPayloadType;

public class streamCreationParams {
	int portLogicalAddress; 
	String streamName;
	streamStates state;
	streamRate rate;
	XenaPacket packet;
	streamBurstParams burst;
	packetPayloadType payloadType;
	String payloadPattern;

	public int getPortLogicalAddress() {
		return portLogicalAddress;
	}

	public void setPortLogicalAddress(int portLogicalAddress) {
		this.portLogicalAddress = portLogicalAddress;
	}

	public String getStreamName() {
		return streamName;
	}

	public void setStreamName(String streamName) {
		this.streamName = streamName;
	}

	public streamStates getState() {
		return state;
	}

	public void setState(streamStates state) {
		this.state = state;
	}

	public streamRate getRate() {
		return rate;
	}
	

	public XenaPacket getPacket() {
		return packet;
	}

	public void setPacket(XenaPacket packet) {
		this.packet = packet;
	}

	public streamBurstParams getBurst() {
		return burst;
	}

	public void setBurst(streamBurstParams burst) {
		this.burst = burst;
	}
	
	public streamCreationParams(int _portLogicalAddress) {
		portLogicalAddress = _portLogicalAddress;
		state = streamStates.Enabled;
		rate = new streamRate();
		packet = new XenaPacket();	
		burst = new streamBurstParams(0, 100);
		payloadType = packetPayloadType.PRBS;
		payloadPattern = new String("0xAABB00FFEE");
	}
	
/*	public streamCreationParams(int _portLogicalAddress, defaultTrafficTypes trafficType) {
		this(_portLogicalAddress);
		
		packetHeader theHeader;
		
		switch (trafficType) {
		case Tagged:
			// Add an Ethernet header
			theHeader = new packetHeader(packetHeaderTypes.ETH);
			this.addHeader(theHeader);
			// Add a CVLAN header
			theHeader = new packetHeader(packetHeaderTypes.CVLAN);
			// Add a SVLAN header
			theHeader = new packetHeader(packetHeaderTypes.SVLAN);
			this.addHeader(theHeader);				
			break;
		case Untagged:
			// Add an Ethernet header
			theHeader = new packetHeader(packetHeaderTypes.ETH);
			this.addHeader(theHeader);
			break;
		default:
			break;
		}
	}*/
	public void addHeader(packetHeader newHeader) {
		this.packet.header.add(newHeader);
		return;
	}

	/**
	 * @return the payloadType
	 */
	public packetPayloadType getPayloadType() {
		return payloadType;
	}

	/**
	 * @param payloadType the payloadType to set
	 */
	public void setPayloadType(packetPayloadType payloadType) {
		this.payloadType = payloadType;
	}

	/**
	 * @return the payloadPattern
	 */
	public String getPayloadPattern() {
		return payloadPattern;
	}

	/**
	 * @param payloadPattern the payloadPattern to set
	 */
	public void setPayloadPattern(String payloadPattern) {
		this.payloadPattern = payloadPattern;
	}

	/**
	 * @param rate the rate to set
	 */
	public void setRate(streamRate rate) {
		this.rate = rate;
	}
	
	public void setRate(streamRateTypes _type, double _value) {
		this.rate.type = _type;
		this.rate.value = _value;
	}
	
}