package xena;

import xena.XenaCom.XenaStatistics;

public class streamRxStatistics {
	streamRxStatistics(XenaStatistics stats) {
		this.bps = stats.bps;
		this.pps = stats.pps;
		this.bytes = stats.bytes;
		this.packets = stats.packets;
		this.receivedPortNumber = stats.getReceivedPortNumber();
	}
	
	public long bps;
	public long pps;
	public long bytes;
	public long packets;
	public long percent;
	protected int receivedPortNumber;
	public int getReceivedPortNumber() {
		return receivedPortNumber;
	}
	public payloadErrors testPayloadErrors;
	
	
	public float getPercent(){
		return (float)(pps*160 + bps) / 10000000 ;
	}
	
	@Override
	public String toString() {
		return String.format("Mbps = %.2f pps = %d bytes = %d packets = %d %s",(double)bps / 1000000, pps, bytes, packets, testPayloadErrors.toString());
	}

	
		
}
// =========================================================================================